# GstBaseParse

This base class is for parser elements that process data and splits it into separate audio/video/whatever frames.

It provides for:

- provides one sink pad and one source pad
- handles state changes
- can operate in pull mode or push mode
- handles seeking in both modes
- handles events (SEGMENT/EOS/FLUSH)
- handles queries (POSITION/DURATION/SEEKING/FORMAT/CONVERT)
- handles flushing

The purpose of this base class is to provide the basic functionality of a parser and share a lot of rather complex code.

# Description of the parsing mechanism:

## Set-up phase

- GstBaseParse calls start to inform subclass that data processing is about to start now.

- GstBaseParse class calls set_sink_caps to inform the subclass about incoming sinkpad caps. Subclass could already set the srcpad caps accordingly, but this might be delayed until calling gst_base_parse_finish_frame with a non-queued frame.

- At least at this point subclass needs to tell the GstBaseParse class how big data chunks it wants to receive (minimum frame size ). It can do this with gst_base_parse_set_min_frame_size.

- GstBaseParse class sets up appropriate data passing mode (pull/push) and starts to process the data.

## Parsing phase

- GstBaseParse gathers at least min_frame_size bytes of data either by pulling it from upstream or collecting buffers in an internal GstAdapter.

- A buffer of (at least) min_frame_size bytes is passed to subclass with handle_frame. Subclass checks the contents and can optionally return GST_FLOW_OK along with an amount of data to be skipped to find a valid frame (which will result in a subsequent DISCONT). If, otherwise, the buffer does not hold a complete frame, handle_frame can merely return and will be called again when additional data is available. In push mode this amounts to an additional input buffer (thus minimal additional latency), in pull mode this amounts to some arbitrary reasonable buffer size increase.

  Of course, gst_base_parse_set_min_frame_size could also be used if a very specific known amount of additional data is required. If, however, the buffer holds a complete valid frame, it can pass the size of this frame to gst_base_parse_finish_frame.

  If acting as a converter, it can also merely indicate consumed input data while simultaneously providing custom output data. Note that baseclass performs some processing (such as tracking overall consumed data rate versus duration) for each finished frame, but other state is only updated upon each call to handle_frame (such as tracking upstream input timestamp).

  Subclass is also responsible for setting the buffer metadata (e.g. buffer timestamp and duration, or keyframe if applicable). (although the latter can also be done by GstBaseParse if it is appropriately configured, see below). Frame is provided with timestamp derived from upstream (as much as generally possible), duration obtained from configuration (see below), and offset if meaningful (in pull mode).

  Note that handle_frame might receive any small amount of input data when leftover data is being drained (e.g. at EOS).

- As part of finish frame processing, just prior to actually pushing the buffer in question, it is passed to pre_push_frame which gives subclass yet one last chance to examine buffer metadata, or to send some custom (tag) events, or to perform custom (segment) filtering.

- During the parsing process GstBaseParseClass will handle both srcpad and sinkpad events. They will be passed to subclass if sink_event or src_event implementations have been provided.

## Shutdown phase

- GstBaseParse class calls stop to inform the subclass that data parsing will be stopped.

Subclass is responsible for providing pad template caps for source and sink pads. The pads need to be named "sink" and "src". It also needs to set the fixed caps on srcpad, when the format is ensured (e.g. when base class calls subclass' set_sink_caps function).

This base class uses GST_FORMAT_DEFAULT as a meaning of frames. So, subclass conversion routine needs to know that conversion from GST_FORMAT_TIME to GST_FORMAT_DEFAULT must return the frame number that can be found from the given byte position.

GstBaseParse uses subclasses conversion methods also for seeking (or otherwise uses its own default one, see also below).

Subclass start and stop functions will be called to inform the beginning and end of data processing.

Things that subclass need to take care of:

- Provide pad templates

- Fixate the source pad caps when appropriate

- Inform base class how big data chunks should be retrieved. This is done with gst_base_parse_set_min_frame_size function.

- Examine data chunks passed to subclass with handle_frame and pass proper frame(s) to gst_base_parse_finish_frame, and setting src pad caps and timestamps on frame.

- Provide conversion functions

- Update the duration information with gst_base_parse_set_duration

- Optionally passthrough using gst_base_parse_set_passthrough

- Configure various baseparse parameters using gst_base_parse_set_average_bitrate, gst_base_parse_set_syncable and gst_base_parse_set_frame_rate.

- In particular, if subclass is unable to determine a duration, but parsing (or specs) yields a frames per seconds rate, then this can be provided to GstBaseParse to enable it to cater for buffer time metadata (which will be taken from upstream as much as possible). Internally keeping track of frame durations and respective sizes that have been pushed provides GstBaseParse with an estimated bitrate. A default convert (used if not overridden) will then use these rates to perform obvious conversions. These rates are also used to update (estimated) duration at regular frame intervals.

## GstBaseParse

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseParse

The opaque GstBaseParse data structure.

### Members

`element` (GstElement) –

the parent element.

`sinkpad` (GstPad *) –
No description available
`srcpad` (GstPad *) –
No description available
`flags` (guint) –
No description available
`segment` (GstSegment) –
No description available

### Class structure

#### GstBaseParseClass

Subclasses can override any of the available virtual methods or not, as needed. At minimum handle_frame needs to be overridden.

##### Fields

`parent_class` (GstElementClass) –

the parent class

### GstBase.BaseParseClass

Subclasses can override any of the available virtual methods or not, as needed. At minimum handle_frame needs to be overridden.

##### Attributes

`parent_class` (Gst.ElementClass) –

the parent class

### GstBase.BaseParseClass

Subclasses can override any of the available virtual methods or not, as needed. At minimum handle_frame needs to be overridden.

##### Attributes

`parent_class` (Gst.ElementClass) –

the parent class

## GstBase.BaseParse

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseParse

The opaque GstBase.BaseParse data structure.

### Members

`element` (Gst.Element) –

the parent element.

`sinkpad` (Gst.Pad) –
No description available
`srcpad` (Gst.Pad) –
No description available
`flags` (Number) –
No description available
`segment` (Gst.Segment) –
No description available

## GstBase.BaseParse

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseParse

The opaque GstBase.BaseParse data structure.

### Members

`element` (Gst.Element) –

the parent element.

`sinkpad` (Gst.Pad) –
No description available
`srcpad` (Gst.Pad) –
No description available
`flags` (int) –
No description available
`segment` (Gst.Segment) –
No description available

### Methods

#### gst_base_parse_add_index_entry

    gboolean
    gst_base_parse_add_index_entry (GstBaseParse * parse,
                                    guint64 offset,
                                    GstClockTime ts,
                                    gboolean key,
                                    gboolean force)

Adds an entry to the index associating offset to ts. It is recommended to only add keyframe entries. force allows to bypass checks, such as whether the stream is (upstream) seekable, another entry is already "close" to the new entry, etc.

Parameters:

`parse` –

GstBaseParse.

`offset` –

offset of entry

`ts` –

timestamp associated with offset

`key` –

whether entry refers to keyframe

`force` –

add entry disregarding sanity checks

Returns –

gboolean indicating whether entry was added

#### GstBase.BaseParse.prototype.add_index_entry

    function GstBase.BaseParse.prototype.add_index_entry(offset: Number, ts: Number, key: Number, force: Number): {
        // javascript wrapper for 'gst_base_parse_add_index_entry'
    }

Adds an entry to the index associating offset to ts. It is recommended to only add keyframe entries. force allows to bypass checks, such as whether the stream is (upstream) seekable, another entry is already "close" to the new entry, etc.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`offset` (Number) –

offset of entry

`ts` (Number) –

timestamp associated with offset

`key` (Number) –

whether entry refers to keyframe

`force` (Number) –

add entry disregarding sanity checks

Returns (Number) –

Number indicating whether entry was added

#### GstBase.BaseParse.add_index_entry

    def GstBase.BaseParse.add_index_entry (self, offset, ts, key, force):
        #python wrapper for 'gst_base_parse_add_index_entry'

Adds an entry to the index associating offset to ts. It is recommended to only add keyframe entries. force allows to bypass checks, such as whether the stream is (upstream) seekable, another entry is already "close" to the new entry, etc.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`offset` (int) –

offset of entry

`ts` (int) –

timestamp associated with offset

`key` (bool) –

whether entry refers to keyframe

`force` (bool) –

add entry disregarding sanity checks

Returns (bool) –

bool indicating whether entry was added

#### gst_base_parse_convert_default

    gboolean
    gst_base_parse_convert_default (GstBaseParse * parse,
                                    GstFormat src_format,
                                    gint64 src_value,
                                    GstFormat dest_format,
                                    gint64 * dest_value)

Default implementation of convert.

Parameters:

`parse` –

GstBaseParse.

`src_format` –

GstFormat describing the source format.

`src_value` –

Source value to be converted.

`dest_format` –

GstFormat defining the converted format.

`dest_value` ( [out]) –

Pointer where the conversion result will be put.

Returns –

TRUE if conversion was successful.

#### GstBase.BaseParse.prototype.convert_default

    function GstBase.BaseParse.prototype.convert_default(src_format: Gst.Format, src_value: Number, dest_format: Gst.Format): {
        // javascript wrapper for 'gst_base_parse_convert_default'
    }

Default implementation of vfunc_convert.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`src_format` (Gst.Format) –

Gst.Format describing the source format.

`src_value` (Number) –

Source value to be converted.

`dest_format` (Gst.Format) –

Gst.Format defining the converted format.

Returns a tuple made of:

(Number ) –

true if conversion was successful.

`dest_value` (Number ) –

true if conversion was successful.

#### GstBase.BaseParse.convert_default

    def GstBase.BaseParse.convert_default (self, src_format, src_value, dest_format):
        #python wrapper for 'gst_base_parse_convert_default'

Default implementation of do_convert.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`src_format` (Gst.Format) –

Gst.Format describing the source format.

`src_value` (int) –

Source value to be converted.

`dest_format` (Gst.Format) –

Gst.Format defining the converted format.

Returns a tuple made of:

(bool ) –

True if conversion was successful.

`dest_value` (int ) –

True if conversion was successful.

#### gst_base_parse_drain

    gst_base_parse_drain (GstBaseParse * parse)

Drains the adapter until it is empty. It decreases the min_frame_size to match the current adapter size and calls chain method until the adapter is emptied or chain returns with error.

Parameters:

`parse` –

a GstBaseParse

Since : 1.12

#### GstBase.BaseParse.prototype.drain

    function GstBase.BaseParse.prototype.drain(): {
        // javascript wrapper for 'gst_base_parse_drain'
    }

Drains the adapter until it is empty. It decreases the min_frame_size to match the current adapter size and calls chain method until the adapter is emptied or chain returns with error.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

Since : 1.12

#### GstBase.BaseParse.drain

    def GstBase.BaseParse.drain (self):
        #python wrapper for 'gst_base_parse_drain'

Drains the adapter until it is empty. It decreases the min_frame_size to match the current adapter size and calls chain method until the adapter is emptied or chain returns with error.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

Since : 1.12

#### gst_base_parse_finish_frame

    GstFlowReturn
    gst_base_parse_finish_frame (GstBaseParse * parse,
                                 GstBaseParseFrame * frame,
                                 gint size)

Collects parsed data and pushes it downstream. Source pad caps must be set when this is called.

If frame's out_buffer is set, that will be used as subsequent frame data, and size amount will be flushed from the input data. The output_buffer size can differ from the consumed size indicated by size.

Otherwise, size samples will be taken from the input and used for output, and the output's metadata (timestamps etc) will be taken as (optionally) set by the subclass on frame's (input) buffer (which is otherwise ignored for any but the above purpose/information).

Note that the latter buffer is invalidated by this call, whereas the caller retains ownership of frame.

Parameters:

`parse` –

a GstBaseParse

`frame` –

a GstBaseParseFrame

`size` –

consumed input data represented by frame

Returns –

a GstFlowReturn that should be escalated to caller (of caller)

#### GstBase.BaseParse.prototype.finish_frame

    function GstBase.BaseParse.prototype.finish_frame(frame: GstBase.BaseParseFrame, size: Number): {
        // javascript wrapper for 'gst_base_parse_finish_frame'
    }

Collects parsed data and pushes it downstream. Source pad caps must be set when this is called.

If frame's out_buffer is set, that will be used as subsequent frame data, and size amount will be flushed from the input data. The output_buffer size can differ from the consumed size indicated by size.

Otherwise, size samples will be taken from the input and used for output, and the output's metadata (timestamps etc) will be taken as (optionally) set by the subclass on frame's (input) buffer (which is otherwise ignored for any but the above purpose/information).

Note that the latter buffer is invalidated by this call, whereas the caller retains ownership of frame.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

`size` (Number) –

consumed input data represented by frame

Returns (Gst.FlowReturn) –

a Gst.FlowReturn that should be escalated to caller (of caller)

#### GstBase.BaseParse.finish_frame

    def GstBase.BaseParse.finish_frame (self, frame, size):
        #python wrapper for 'gst_base_parse_finish_frame'

Collects parsed data and pushes it downstream. Source pad caps must be set when this is called.

If frame's out_buffer is set, that will be used as subsequent frame data, and size amount will be flushed from the input data. The output_buffer size can differ from the consumed size indicated by size.

Otherwise, size samples will be taken from the input and used for output, and the output's metadata (timestamps etc) will be taken as (optionally) set by the subclass on frame's (input) buffer (which is otherwise ignored for any but the above purpose/information).

Note that the latter buffer is invalidated by this call, whereas the caller retains ownership of frame.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

`size` (int) –

consumed input data represented by frame

Returns (Gst.FlowReturn) –

a Gst.FlowReturn that should be escalated to caller (of caller)

#### gst_base_parse_merge_tags

    gst_base_parse_merge_tags (GstBaseParse * parse,
                               GstTagList * tags,
                               GstTagMergeMode mode)

Sets the parser subclass's tags and how they should be merged with any upstream stream tags. This will override any tags previously-set with gst_base_parse_merge_tags.

Note that this is provided for convenience, and the subclass is not required to use this and can still do tag handling on its own.

Parameters:

`parse` –

a GstBaseParse

`tags` ( [allow-none]) –

a GstTagList to merge, or NULL to unset previously-set tags

`mode` –

the GstTagMergeMode to use, usually GST_TAG_MERGE_REPLACE

Since : 1.6

#### GstBase.BaseParse.prototype.merge_tags

    function GstBase.BaseParse.prototype.merge_tags(tags: Gst.TagList, mode: Gst.TagMergeMode): {
        // javascript wrapper for 'gst_base_parse_merge_tags'
    }

Sets the parser subclass's tags and how they should be merged with any upstream stream tags. This will override any tags previously-set with GstBase.BaseParse.prototype.merge_tags.

Note that this is provided for convenience, and the subclass is not required to use this and can still do tag handling on its own.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`tags` (Gst.TagList) –

a Gst.TagList to merge, or NULL to unset previously-set tags

`mode` (Gst.TagMergeMode) –

the Gst.TagMergeMode to use, usually Gst.TagMergeMode.REPLACE

Since : 1.6

#### GstBase.BaseParse.merge_tags

    def GstBase.BaseParse.merge_tags (self, tags, mode):
        #python wrapper for 'gst_base_parse_merge_tags'

Sets the parser subclass's tags and how they should be merged with any upstream stream tags. This will override any tags previously-set with GstBase.BaseParse.merge_tags.

Note that this is provided for convenience, and the subclass is not required to use this and can still do tag handling on its own.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`tags` (Gst.TagList) –

a Gst.TagList to merge, or NULL to unset previously-set tags

`mode` (Gst.TagMergeMode) –

the Gst.TagMergeMode to use, usually Gst.TagMergeMode.REPLACE

Since : 1.6

#### gst_base_parse_push_frame

    GstFlowReturn
    gst_base_parse_push_frame (GstBaseParse * parse,
                               GstBaseParseFrame * frame)

Pushes the frame's buffer downstream, sends any pending events and does some timestamp and segment handling. Takes ownership of frame's buffer, though caller retains ownership of frame.

This must be called with sinkpad STREAM_LOCK held.

Parameters:

`parse` –

GstBaseParse.

`frame` ( [transfer: none]) –

a GstBaseParseFrame

Returns –

GstFlowReturn

#### GstBase.BaseParse.prototype.push_frame

    function GstBase.BaseParse.prototype.push_frame(frame: GstBase.BaseParseFrame): {
        // javascript wrapper for 'gst_base_parse_push_frame'
    }

Pushes the frame's buffer downstream, sends any pending events and does some timestamp and segment handling. Takes ownership of frame's buffer, though caller retains ownership of frame.

This must be called with sinkpad STREAM_LOCK held.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

Returns (Gst.FlowReturn) –

Gst.FlowReturn

#### GstBase.BaseParse.push_frame

    def GstBase.BaseParse.push_frame (self, frame):
        #python wrapper for 'gst_base_parse_push_frame'

Pushes the frame's buffer downstream, sends any pending events and does some timestamp and segment handling. Takes ownership of frame's buffer, though caller retains ownership of frame.

This must be called with sinkpad STREAM_LOCK held.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

Returns (Gst.FlowReturn) –

Gst.FlowReturn

#### gst_base_parse_set_average_bitrate

    gst_base_parse_set_average_bitrate (GstBaseParse * parse,
                                        guint bitrate)

Optionally sets the average bitrate detected in media (if non-zero), e.g. based on metadata, as it will be posted to the application.

By default, announced average bitrate is estimated. The average bitrate is used to estimate the total duration of the stream and to estimate a seek position, if there's no index and the format is syncable (see gst_base_parse_set_syncable).

Parameters:

`parse` –

GstBaseParse.

`bitrate` –

average bitrate in bits/second

#### GstBase.BaseParse.prototype.set_average_bitrate

    function GstBase.BaseParse.prototype.set_average_bitrate(bitrate: Number): {
        // javascript wrapper for 'gst_base_parse_set_average_bitrate'
    }

Optionally sets the average bitrate detected in media (if non-zero), e.g. based on metadata, as it will be posted to the application.

By default, announced average bitrate is estimated. The average bitrate is used to estimate the total duration of the stream and to estimate a seek position, if there's no index and the format is syncable (see GstBase.BaseParse.prototype.set_syncable).

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`bitrate` (Number) –

average bitrate in bits/second

#### GstBase.BaseParse.set_average_bitrate

    def GstBase.BaseParse.set_average_bitrate (self, bitrate):
        #python wrapper for 'gst_base_parse_set_average_bitrate'

Optionally sets the average bitrate detected in media (if non-zero), e.g. based on metadata, as it will be posted to the application.

By default, announced average bitrate is estimated. The average bitrate is used to estimate the total duration of the stream and to estimate a seek position, if there's no index and the format is syncable (see GstBase.BaseParse.set_syncable).

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`bitrate` (int) –

average bitrate in bits/second

#### gst_base_parse_set_duration

    gst_base_parse_set_duration (GstBaseParse * parse,
                                 GstFormat fmt,
                                 gint64 duration,
                                 gint interval)

Sets the duration of the currently playing media. Subclass can use this when it is able to determine duration and/or notices a change in the media duration. Alternatively, if interval is non-zero (default), then stream duration is determined based on estimated bitrate, and updated every interval frames.

Parameters:

`parse` –

GstBaseParse.

`fmt` –

GstFormat.

`duration` –

duration value.

`interval` –

how often to update the duration estimate based on bitrate, or 0.

#### GstBase.BaseParse.prototype.set_duration

    function GstBase.BaseParse.prototype.set_duration(fmt: Gst.Format, duration: Number, interval: Number): {
        // javascript wrapper for 'gst_base_parse_set_duration'
    }

Sets the duration of the currently playing media. Subclass can use this when it is able to determine duration and/or notices a change in the media duration. Alternatively, if interval is non-zero (default), then stream duration is determined based on estimated bitrate, and updated every interval frames.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`fmt` (Gst.Format) –

Gst.Format.

`duration` (Number) –

duration value.

`interval` (Number) –

how often to update the duration estimate based on bitrate, or 0.

#### GstBase.BaseParse.set_duration

    def GstBase.BaseParse.set_duration (self, fmt, duration, interval):
        #python wrapper for 'gst_base_parse_set_duration'

Sets the duration of the currently playing media. Subclass can use this when it is able to determine duration and/or notices a change in the media duration. Alternatively, if interval is non-zero (default), then stream duration is determined based on estimated bitrate, and updated every interval frames.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`fmt` (Gst.Format) –

Gst.Format.

`duration` (int) –

duration value.

`interval` (int) –

how often to update the duration estimate based on bitrate, or 0.

#### gst_base_parse_set_frame_rate

    gst_base_parse_set_frame_rate (GstBaseParse * parse,
                                   guint fps_num,
                                   guint fps_den,
                                   guint lead_in,
                                   guint lead_out)

If frames per second is configured, parser can take care of buffer duration and timestamping. When performing segment clipping, or seeking to a specific location, a corresponding decoder might need an initial lead_in and a following lead_out number of frames to ensure the desired segment is entirely filled upon decoding.

Parameters:

`parse` –

the GstBaseParse to set

`fps_num` –

frames per second (numerator).

`fps_den` –

frames per second (denominator).

`lead_in` –

frames needed before a segment for subsequent decode

`lead_out` –

frames needed after a segment

#### GstBase.BaseParse.prototype.set_frame_rate

    function GstBase.BaseParse.prototype.set_frame_rate(fps_num: Number, fps_den: Number, lead_in: Number, lead_out: Number): {
        // javascript wrapper for 'gst_base_parse_set_frame_rate'
    }

If frames per second is configured, parser can take care of buffer duration and timestamping. When performing segment clipping, or seeking to a specific location, a corresponding decoder might need an initial lead_in and a following lead_out number of frames to ensure the desired segment is entirely filled upon decoding.

Parameters:

`parse` (GstBase.BaseParse) –

the GstBase.BaseParse to set

`fps_num` (Number) –

frames per second (numerator).

`fps_den` (Number) –

frames per second (denominator).

`lead_in` (Number) –

frames needed before a segment for subsequent decode

`lead_out` (Number) –

frames needed after a segment

#### GstBase.BaseParse.set_frame_rate

    def GstBase.BaseParse.set_frame_rate (self, fps_num, fps_den, lead_in, lead_out):
        #python wrapper for 'gst_base_parse_set_frame_rate'

If frames per second is configured, parser can take care of buffer duration and timestamping. When performing segment clipping, or seeking to a specific location, a corresponding decoder might need an initial lead_in and a following lead_out number of frames to ensure the desired segment is entirely filled upon decoding.

Parameters:

`parse` (GstBase.BaseParse) –

the GstBase.BaseParse to set

`fps_num` (int) –

frames per second (numerator).

`fps_den` (int) –

frames per second (denominator).

`lead_in` (int) –

frames needed before a segment for subsequent decode

`lead_out` (int) –

frames needed after a segment

#### gst_base_parse_set_has_timing_info

    gst_base_parse_set_has_timing_info (GstBaseParse * parse,
                                        gboolean has_timing)

Set if frames carry timing information which the subclass can (generally) parse and provide. In particular, intrinsic (rather than estimated) time can be obtained following a seek.

Parameters:

`parse` –

a GstBaseParse

`has_timing` –

whether frames carry timing information

#### GstBase.BaseParse.prototype.set_has_timing_info

    function GstBase.BaseParse.prototype.set_has_timing_info(has_timing: Number): {
        // javascript wrapper for 'gst_base_parse_set_has_timing_info'
    }

Set if frames carry timing information which the subclass can (generally) parse and provide. In particular, intrinsic (rather than estimated) time can be obtained following a seek.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`has_timing` (Number) –

whether frames carry timing information

#### GstBase.BaseParse.set_has_timing_info

    def GstBase.BaseParse.set_has_timing_info (self, has_timing):
        #python wrapper for 'gst_base_parse_set_has_timing_info'

Set if frames carry timing information which the subclass can (generally) parse and provide. In particular, intrinsic (rather than estimated) time can be obtained following a seek.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`has_timing` (bool) –

whether frames carry timing information

#### gst_base_parse_set_infer_ts

    gst_base_parse_set_infer_ts (GstBaseParse * parse,
                                 gboolean infer_ts)

By default, the base class might try to infer PTS from DTS and vice versa. While this is generally correct for audio data, it may not be otherwise. Sub-classes implementing such formats should disable timestamp inferring.

Parameters:

`parse` –

a GstBaseParse

`infer_ts` –

TRUE if parser should infer DTS/PTS from each other

#### GstBase.BaseParse.prototype.set_infer_ts

    function GstBase.BaseParse.prototype.set_infer_ts(infer_ts: Number): {
        // javascript wrapper for 'gst_base_parse_set_infer_ts'
    }

By default, the base class might try to infer PTS from DTS and vice versa. While this is generally correct for audio data, it may not be otherwise. Sub-classes implementing such formats should disable timestamp inferring.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`infer_ts` (Number) –

true if parser should infer DTS/PTS from each other

#### GstBase.BaseParse.set_infer_ts

    def GstBase.BaseParse.set_infer_ts (self, infer_ts):
        #python wrapper for 'gst_base_parse_set_infer_ts'

By default, the base class might try to infer PTS from DTS and vice versa. While this is generally correct for audio data, it may not be otherwise. Sub-classes implementing such formats should disable timestamp inferring.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`infer_ts` (bool) –

True if parser should infer DTS/PTS from each other

#### gst_base_parse_set_latency

    gst_base_parse_set_latency (GstBaseParse * parse,
                                GstClockTime min_latency,
                                GstClockTime max_latency)

Sets the minimum and maximum (which may likely be equal) latency introduced by the parsing process. If there is such a latency, which depends on the particular parsing of the format, it typically corresponds to 1 frame duration.

If the provided values changed from previously provided ones, this will also post a LATENCY message on the bus so the pipeline can reconfigure its global latency.

Parameters:

`parse` –

a GstBaseParse

`min_latency` –

minimum parse latency

`max_latency` –

maximum parse latency

#### GstBase.BaseParse.prototype.set_latency

    function GstBase.BaseParse.prototype.set_latency(min_latency: Number, max_latency: Number): {
        // javascript wrapper for 'gst_base_parse_set_latency'
    }

Sets the minimum and maximum (which may likely be equal) latency introduced by the parsing process. If there is such a latency, which depends on the particular parsing of the format, it typically corresponds to 1 frame duration.

If the provided values changed from previously provided ones, this will also post a LATENCY message on the bus so the pipeline can reconfigure its global latency.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`min_latency` (Number) –

minimum parse latency

`max_latency` (Number) –

maximum parse latency

#### GstBase.BaseParse.set_latency

    def GstBase.BaseParse.set_latency (self, min_latency, max_latency):
        #python wrapper for 'gst_base_parse_set_latency'

Sets the minimum and maximum (which may likely be equal) latency introduced by the parsing process. If there is such a latency, which depends on the particular parsing of the format, it typically corresponds to 1 frame duration.

If the provided values changed from previously provided ones, this will also post a LATENCY message on the bus so the pipeline can reconfigure its global latency.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`min_latency` (int) –

minimum parse latency

`max_latency` (int) –

maximum parse latency

#### gst_base_parse_set_min_frame_size

    gst_base_parse_set_min_frame_size (GstBaseParse * parse,
                                       guint min_size)

Subclass can use this function to tell the base class that it needs to be given buffers of at least min_size bytes.

Parameters:

`parse` –

GstBaseParse.

`min_size` –

Minimum size in bytes of the data that this base class should give to subclass.

#### GstBase.BaseParse.prototype.set_min_frame_size

    function GstBase.BaseParse.prototype.set_min_frame_size(min_size: Number): {
        // javascript wrapper for 'gst_base_parse_set_min_frame_size'
    }

Subclass can use this function to tell the base class that it needs to be given buffers of at least min_size bytes.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`min_size` (Number) –

Minimum size in bytes of the data that this base class should give to subclass.

#### GstBase.BaseParse.set_min_frame_size

    def GstBase.BaseParse.set_min_frame_size (self, min_size):
        #python wrapper for 'gst_base_parse_set_min_frame_size'

Subclass can use this function to tell the base class that it needs to be given buffers of at least min_size bytes.

Parameters:

`parse` (GstBase.BaseParse) –

GstBase.BaseParse.

`min_size` (int) –

Minimum size in bytes of the data that this base class should give to subclass.

#### gst_base_parse_set_passthrough

    gst_base_parse_set_passthrough (GstBaseParse * parse,
                                    gboolean passthrough)

Set if the nature of the format or configuration does not allow (much) parsing, and the parser should operate in passthrough mode (which only applies when operating in push mode). That is, incoming buffers are pushed through unmodified, i.e. no handle_frame will be invoked, but pre_push_frame will still be invoked, so subclass can perform as much or as little is appropriate for passthrough semantics in pre_push_frame.

Parameters:

`parse` –

a GstBaseParse

`passthrough` –

TRUE if parser should run in passthrough mode

#### GstBase.BaseParse.prototype.set_passthrough

    function GstBase.BaseParse.prototype.set_passthrough(passthrough: Number): {
        // javascript wrapper for 'gst_base_parse_set_passthrough'
    }

Set if the nature of the format or configuration does not allow (much) parsing, and the parser should operate in passthrough mode (which only applies when operating in push mode). That is, incoming buffers are pushed through unmodified, i.e. no vfunc_handle_frame will be invoked, but vfunc_pre_push_frame will still be invoked, so subclass can perform as much or as little is appropriate for passthrough semantics in vfunc_pre_push_frame.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`passthrough` (Number) –

true if parser should run in passthrough mode

#### GstBase.BaseParse.set_passthrough

    def GstBase.BaseParse.set_passthrough (self, passthrough):
        #python wrapper for 'gst_base_parse_set_passthrough'

Set if the nature of the format or configuration does not allow (much) parsing, and the parser should operate in passthrough mode (which only applies when operating in push mode). That is, incoming buffers are pushed through unmodified, i.e. no do_handle_frame will be invoked, but do_pre_push_frame will still be invoked, so subclass can perform as much or as little is appropriate for passthrough semantics in do_pre_push_frame.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`passthrough` (bool) –

True if parser should run in passthrough mode

#### gst_base_parse_set_pts_interpolation

    gst_base_parse_set_pts_interpolation (GstBaseParse * parse,
                                          gboolean pts_interpolate)

By default, the base class will guess PTS timestamps using a simple interpolation (previous timestamp + duration), which is incorrect for data streams with reordering, where PTS can go backward. Sub-classes implementing such formats should disable PTS interpolation.

Parameters:

`parse` –

a GstBaseParse

`pts_interpolate` –

TRUE if parser should interpolate PTS timestamps

#### GstBase.BaseParse.prototype.set_pts_interpolation

    function GstBase.BaseParse.prototype.set_pts_interpolation(pts_interpolate: Number): {
        // javascript wrapper for 'gst_base_parse_set_pts_interpolation'
    }

By default, the base class will guess PTS timestamps using a simple interpolation (previous timestamp + duration), which is incorrect for data streams with reordering, where PTS can go backward. Sub-classes implementing such formats should disable PTS interpolation.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`pts_interpolate` (Number) –

true if parser should interpolate PTS timestamps

#### GstBase.BaseParse.set_pts_interpolation

    def GstBase.BaseParse.set_pts_interpolation (self, pts_interpolate):
        #python wrapper for 'gst_base_parse_set_pts_interpolation'

By default, the base class will guess PTS timestamps using a simple interpolation (previous timestamp + duration), which is incorrect for data streams with reordering, where PTS can go backward. Sub-classes implementing such formats should disable PTS interpolation.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`pts_interpolate` (bool) –

True if parser should interpolate PTS timestamps

#### gst_base_parse_set_syncable

    gst_base_parse_set_syncable (GstBaseParse * parse,
                                 gboolean syncable)

Set if frame starts can be identified. This is set by default and determines whether seeking based on bitrate averages is possible for a format/stream.

Parameters:

`parse` –

a GstBaseParse

`syncable` –

set if frame starts can be identified

#### GstBase.BaseParse.prototype.set_syncable

    function GstBase.BaseParse.prototype.set_syncable(syncable: Number): {
        // javascript wrapper for 'gst_base_parse_set_syncable'
    }

Set if frame starts can be identified. This is set by default and determines whether seeking based on bitrate averages is possible for a format/stream.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`syncable` (Number) –

set if frame starts can be identified

#### GstBase.BaseParse.set_syncable

    def GstBase.BaseParse.set_syncable (self, syncable):
        #python wrapper for 'gst_base_parse_set_syncable'

Set if frame starts can be identified. This is set by default and determines whether seeking based on bitrate averages is possible for a format/stream.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`syncable` (bool) –

set if frame starts can be identified

#### gst_base_parse_set_ts_at_offset

    gst_base_parse_set_ts_at_offset (GstBaseParse * parse,
                                     gsize offset)

This function should only be called from a handle_frame implementation.

GstBaseParse creates initial timestamps for frames by using the last timestamp seen in the stream before the frame starts. In certain cases, the correct timestamps will occur in the stream after the start of the frame, but before the start of the actual picture data. This function can be used to set the timestamps based on the offset into the frame data that the picture starts.

Parameters:

`parse` –

a GstBaseParse

`offset` –

offset into current buffer

Since : 1.2

#### GstBase.BaseParse.prototype.set_ts_at_offset

    function GstBase.BaseParse.prototype.set_ts_at_offset(offset: Number): {
        // javascript wrapper for 'gst_base_parse_set_ts_at_offset'
    }

This function should only be called from a handle_frame implementation.

GstBase.BaseParse creates initial timestamps for frames by using the last timestamp seen in the stream before the frame starts. In certain cases, the correct timestamps will occur in the stream after the start of the frame, but before the start of the actual picture data. This function can be used to set the timestamps based on the offset into the frame data that the picture starts.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`offset` (Number) –

offset into current buffer

Since : 1.2

#### GstBase.BaseParse.set_ts_at_offset

    def GstBase.BaseParse.set_ts_at_offset (self, offset):
        #python wrapper for 'gst_base_parse_set_ts_at_offset'

This function should only be called from a handle_frame implementation.

GstBase.BaseParse creates initial timestamps for frames by using the last timestamp seen in the stream before the frame starts. In certain cases, the correct timestamps will occur in the stream after the start of the frame, but before the start of the actual picture data. This function can be used to set the timestamps based on the offset into the frame data that the picture starts.

Parameters:

`parse` (GstBase.BaseParse) –

a GstBase.BaseParse

`offset` (int) –

offset into current buffer

Since : 1.2

### Properties

#### disable-passthrough

    “disable-passthrough” gboolean

If set to TRUE, baseparse will unconditionally force parsing of the incoming data. This can be required in the rare cases where the incoming side-data (caps, pts, dts, ...) is not trusted by the user and wants to force validation and parsing of the incoming data. If set to FALSE, decision of whether to parse the data or not is up to the implementation (standard behaviour).

Flags : Read / Write

#### disable-passthrough

    “disable-passthrough” Number

If set to true, baseparse will unconditionally force parsing of the incoming data. This can be required in the rare cases where the incoming side-data (caps, pts, dts, ...) is not trusted by the user and wants to force validation and parsing of the incoming data. If set to false, decision of whether to parse the data or not is up to the implementation (standard behaviour).

Flags : Read / Write

#### disable_passthrough

    “self.props.disable_passthrough” bool

If set to True, baseparse will unconditionally force parsing of the incoming data. This can be required in the rare cases where the incoming side-data (caps, pts, dts, ...) is not trusted by the user and wants to force validation and parsing of the incoming data. If set to False, decision of whether to parse the data or not is up to the implementation (standard behaviour).

Flags : Read / Write

### Virtual Methods

#### convert

    gboolean
    convert (GstBaseParse * parse,
             GstFormat src_format,
             gint64 src_value,
             GstFormat dest_format,
             gint64 * dest_value)

Optional. Convert between formats.

Parameters:

`parse` –
No description available
`src_format` –
No description available
`src_value` –
No description available
`dest_format` –
No description available
`dest_value` –
No description available
Returns –
No description available

#### vfunc_convert

    function vfunc_convert(parse: GstBase.BaseParse, src_format: Gst.Format, src_value: Number, dest_format: Gst.Format, dest_value: Number): {
        // javascript implementation of the 'convert' virtual method
    }

Optional. Convert between formats.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`src_format` (Gst.Format) –
No description available
`src_value` (Number) –
No description available
`dest_format` (Gst.Format) –
No description available
`dest_value` (Number) –
No description available
Returns (Number) –
No description available

#### do_convert

    def do_convert (parse, src_format, src_value, dest_format, dest_value):
        #python implementation of the 'convert' virtual method

Optional. Convert between formats.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`src_format` (Gst.Format) –
No description available
`src_value` (int) –
No description available
`dest_format` (Gst.Format) –
No description available
`dest_value` (int) –
No description available
Returns (bool) –
No description available

#### detect

    GstFlowReturn
    detect (GstBaseParse * parse,
            GstBuffer * buffer)

Optional. Called until it doesn't return GST_FLOW_OK anymore for the first buffers. Can be used by the subclass to detect the stream format.

Parameters:

`parse` –
No description available
`buffer` –
No description available
Returns –
No description available

#### vfunc_detect

    function vfunc_detect(parse: GstBase.BaseParse, buffer: Gst.Buffer): {
        // javascript implementation of the 'detect' virtual method
    }

Optional. Called until it doesn't return GST_FLOW_OK anymore for the first buffers. Can be used by the subclass to detect the stream format.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_detect

    def do_detect (parse, buffer):
        #python implementation of the 'detect' virtual method

Optional. Called until it doesn't return GST_FLOW_OK anymore for the first buffers. Can be used by the subclass to detect the stream format.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`buffer` (Gst.Buffer) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### get_sink_caps

    GstCaps *
    get_sink_caps (GstBaseParse * parse,
                   GstCaps * filter)

Optional. Allows the subclass to do its own sink get caps if needed.

Parameters:

`parse` –
No description available
`filter` –
No description available
Returns –
No description available

#### vfunc_get_sink_caps

    function vfunc_get_sink_caps(parse: GstBase.BaseParse, filter: Gst.Caps): {
        // javascript implementation of the 'get_sink_caps' virtual method
    }

Optional. Allows the subclass to do its own sink get caps if needed.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### do_get_sink_caps

    def do_get_sink_caps (parse, filter):
        #python implementation of the 'get_sink_caps' virtual method

Optional. Allows the subclass to do its own sink get caps if needed.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### handle_frame

    GstFlowReturn
    handle_frame (GstBaseParse * parse,
                  GstBaseParseFrame * frame,
                  gint * skipsize)

Parses the input data into valid frames as defined by subclass which should be passed to gst_base_parse_finish_frame. The frame's input buffer is guaranteed writable, whereas the input frame ownership is held by caller (so subclass should make a copy if it needs to hang on). Input buffer (data) is provided by baseclass with as much metadata set as possible by baseclass according to upstream information and/or subclass settings, though subclass may still set buffer timestamp and duration if desired.

Parameters:

`parse` –
No description available
`frame` –
No description available
`skipsize` –
No description available
Returns –
No description available

#### vfunc_handle_frame

    function vfunc_handle_frame(parse: GstBase.BaseParse, frame: GstBase.BaseParseFrame): {
        // javascript implementation of the 'handle_frame' virtual method
    }

Parses the input data into valid frames as defined by subclass which should be passed to GstBase.BaseParse.prototype.finish_frame. The frame's input buffer is guaranteed writable, whereas the input frame ownership is held by caller (so subclass should make a copy if it needs to hang on). Input buffer (data) is provided by baseclass with as much metadata set as possible by baseclass according to upstream information and/or subclass settings, though subclass may still set buffer timestamp and duration if desired.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`frame` (GstBase.BaseParseFrame) –
No description available

Returns a tuple made of:

(Gst.FlowReturn ) –
No description available
`skipsize` (Number ) –
No description available

#### do_handle_frame

    def do_handle_frame (parse, frame):
        #python implementation of the 'handle_frame' virtual method

Parses the input data into valid frames as defined by subclass which should be passed to GstBase.BaseParse.finish_frame. The frame's input buffer is guaranteed writable, whereas the input frame ownership is held by caller (so subclass should make a copy if it needs to hang on). Input buffer (data) is provided by baseclass with as much metadata set as possible by baseclass according to upstream information and/or subclass settings, though subclass may still set buffer timestamp and duration if desired.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`frame` (GstBase.BaseParseFrame) –
No description available

Returns a tuple made of:

(Gst.FlowReturn ) –
No description available
`skipsize` (int ) –
No description available

#### pre_push_frame

    GstFlowReturn
    pre_push_frame (GstBaseParse * parse,
                    GstBaseParseFrame * frame)

Optional. Called just prior to pushing a frame (after any pending events have been sent) to give subclass a chance to perform additional actions at this time (e.g. tag sending) or to decide whether this buffer should be dropped or not (e.g. custom segment clipping).

Parameters:

`parse` –
No description available
`frame` –
No description available
Returns –
No description available

#### vfunc_pre_push_frame

    function vfunc_pre_push_frame(parse: GstBase.BaseParse, frame: GstBase.BaseParseFrame): {
        // javascript implementation of the 'pre_push_frame' virtual method
    }

Optional. Called just prior to pushing a frame (after any pending events have been sent) to give subclass a chance to perform additional actions at this time (e.g. tag sending) or to decide whether this buffer should be dropped or not (e.g. custom segment clipping).

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`frame` (GstBase.BaseParseFrame) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### do_pre_push_frame

    def do_pre_push_frame (parse, frame):
        #python implementation of the 'pre_push_frame' virtual method

Optional. Called just prior to pushing a frame (after any pending events have been sent) to give subclass a chance to perform additional actions at this time (e.g. tag sending) or to decide whether this buffer should be dropped or not (e.g. custom segment clipping).

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`frame` (GstBase.BaseParseFrame) –
No description available
Returns (Gst.FlowReturn) –
No description available

#### set_sink_caps

    gboolean
    set_sink_caps (GstBaseParse * parse,
                   GstCaps * caps)

Optional. Allows the subclass to be notified of the actual caps set.

Parameters:

`parse` –
No description available
`caps` –
No description available
Returns –
No description available

#### vfunc_set_sink_caps

    function vfunc_set_sink_caps(parse: GstBase.BaseParse, caps: Gst.Caps): {
        // javascript implementation of the 'set_sink_caps' virtual method
    }

Optional. Allows the subclass to be notified of the actual caps set.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (Number) –
No description available

#### do_set_sink_caps

    def do_set_sink_caps (parse, caps):
        #python implementation of the 'set_sink_caps' virtual method

Optional. Allows the subclass to be notified of the actual caps set.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`caps` (Gst.Caps) –
No description available
Returns (bool) –
No description available

#### sink_event

    gboolean
    sink_event (GstBaseParse * parse,
                GstEvent * event)

Optional. Event handler on the sink pad. This function should chain up to the parent implementation to let the default handler run.

Parameters:

`parse` –
No description available
`event` –
No description available
Returns –
No description available

#### vfunc_sink_event

    function vfunc_sink_event(parse: GstBase.BaseParse, event: Gst.Event): {
        // javascript implementation of the 'sink_event' virtual method
    }

Optional. Event handler on the sink pad. This function should chain up to the parent implementation to let the default handler run.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`event` (Gst.Event) –
No description available
Returns (Number) –
No description available

#### do_sink_event

    def do_sink_event (parse, event):
        #python implementation of the 'sink_event' virtual method

Optional. Event handler on the sink pad. This function should chain up to the parent implementation to let the default handler run.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`event` (Gst.Event) –
No description available
Returns (bool) –
No description available

#### sink_query

    gboolean
    sink_query (GstBaseParse * parse,
                GstQuery * query)

Optional. Query handler on the sink pad. This function should chain up to the parent implementation to let the default handler run (Since: 1.2)

Parameters:

`parse` –
No description available
`query` –
No description available
Returns –
No description available

#### vfunc_sink_query

    function vfunc_sink_query(parse: GstBase.BaseParse, query: Gst.Query): {
        // javascript implementation of the 'sink_query' virtual method
    }

Optional. Query handler on the sink pad. This function should chain up to the parent implementation to let the default handler run (Since: 1.2)

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`query` (Gst.Query) –
No description available
Returns (Number) –
No description available

#### do_sink_query

    def do_sink_query (parse, query):
        #python implementation of the 'sink_query' virtual method

Optional. Query handler on the sink pad. This function should chain up to the parent implementation to let the default handler run (Since: 1.2)

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`query` (Gst.Query) –
No description available
Returns (bool) –
No description available

#### src_event

    gboolean
    src_event (GstBaseParse * parse,
               GstEvent * event)

Optional. Event handler on the source pad. Should chain up to the parent to let the default handler run.

Parameters:

`parse` –
No description available
`event` –
No description available
Returns –
No description available

#### vfunc_src_event

    function vfunc_src_event(parse: GstBase.BaseParse, event: Gst.Event): {
        // javascript implementation of the 'src_event' virtual method
    }

Optional. Event handler on the source pad. Should chain up to the parent to let the default handler run.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`event` (Gst.Event) –
No description available
Returns (Number) –
No description available

#### do_src_event

    def do_src_event (parse, event):
        #python implementation of the 'src_event' virtual method

Optional. Event handler on the source pad. Should chain up to the parent to let the default handler run.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`event` (Gst.Event) –
No description available
Returns (bool) –
No description available

#### src_query

    gboolean
    src_query (GstBaseParse * parse,
               GstQuery * query)

Optional. Query handler on the source pad. Should chain up to the parent to let the default handler run (Since: 1.2)

Parameters:

`parse` –
No description available
`query` –
No description available
Returns –
No description available

#### vfunc_src_query

    function vfunc_src_query(parse: GstBase.BaseParse, query: Gst.Query): {
        // javascript implementation of the 'src_query' virtual method
    }

Optional. Query handler on the source pad. Should chain up to the parent to let the default handler run (Since: 1.2)

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`query` (Gst.Query) –
No description available
Returns (Number) –
No description available

#### do_src_query

    def do_src_query (parse, query):
        #python implementation of the 'src_query' virtual method

Optional. Query handler on the source pad. Should chain up to the parent to let the default handler run (Since: 1.2)

Parameters:

`parse` (GstBase.BaseParse) –
No description available
`query` (Gst.Query) –
No description available
Returns (bool) –
No description available

#### start

    gboolean
    start (GstBaseParse * parse)

Optional. Called when the element starts processing. Allows opening external resources.

Parameters:

`parse` –
No description available
Returns –
No description available

#### vfunc_start

    function vfunc_start(parse: GstBase.BaseParse): {
        // javascript implementation of the 'start' virtual method
    }

Optional. Called when the element starts processing. Allows opening external resources.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
Returns (Number) –
No description available

#### do_start

    def do_start (parse):
        #python implementation of the 'start' virtual method

Optional. Called when the element starts processing. Allows opening external resources.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
Returns (bool) –
No description available

#### stop

    gboolean
    stop (GstBaseParse * parse)

Optional. Called when the element stops processing. Allows closing external resources.

Parameters:

`parse` –
No description available
Returns –
No description available

#### vfunc_stop

    function vfunc_stop(parse: GstBase.BaseParse): {
        // javascript implementation of the 'stop' virtual method
    }

Optional. Called when the element stops processing. Allows closing external resources.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
Returns (Number) –
No description available

#### do_stop

    def do_stop (parse):
        #python implementation of the 'stop' virtual method

Optional. Called when the element stops processing. Allows closing external resources.

Parameters:

`parse` (GstBase.BaseParse) –
No description available
Returns (bool) –
No description available

## GstBaseParseFrame

Frame (context) data passed to each frame parsing virtual methods. In addition to providing the data to be checked for a valid frame or an already identified frame, it conveys additional metadata or control information from and to the subclass w.r.t. the particular frame in question (rather than global parameters). Some of these may apply to each parsing stage, others only to some a particular one. These parameters are effectively zeroed at start of each frame's processing, i.e. parsing virtual method invocation sequence.

### Members

`buffer` (GstBuffer *) –

input data to be parsed for frames.

`out_buffer` (GstBuffer *) –

output data.

`flags` (guint) –

a combination of input and output GstBaseParseFrameFlags that convey additional context to subclass or allow subclass to tune subsequent GstBaseParse actions.

`offset` (guint64) –

media specific offset of input frame Note that a converter may have a different one on the frame's buffer.

`overhead` (gint) –

subclass can set this to indicates the metadata overhead for the given frame, which is then used to enable more accurate bitrate computations. If this is -1, it is assumed that this frame should be skipped in bitrate calculation.

## GstBase.BaseParseFrame

Frame (context) data passed to each frame parsing virtual methods. In addition to providing the data to be checked for a valid frame or an already identified frame, it conveys additional metadata or control information from and to the subclass w.r.t. the particular frame in question (rather than global parameters). Some of these may apply to each parsing stage, others only to some a particular one. These parameters are effectively zeroed at start of each frame's processing, i.e. parsing virtual method invocation sequence.

### Members

`buffer` (Gst.Buffer) –

input data to be parsed for frames.

`out_buffer` (Gst.Buffer) –

output data.

`flags` (Number) –

a combination of input and output GstBase.BaseParseFrameFlags that convey additional context to subclass or allow subclass to tune subsequent GstBase.BaseParse actions.

`offset` (Number) –

media specific offset of input frame Note that a converter may have a different one on the frame's buffer.

`overhead` (Number) –

subclass can set this to indicates the metadata overhead for the given frame, which is then used to enable more accurate bitrate computations. If this is -1, it is assumed that this frame should be skipped in bitrate calculation.

## GstBase.BaseParseFrame

Frame (context) data passed to each frame parsing virtual methods. In addition to providing the data to be checked for a valid frame or an already identified frame, it conveys additional metadata or control information from and to the subclass w.r.t. the particular frame in question (rather than global parameters). Some of these may apply to each parsing stage, others only to some a particular one. These parameters are effectively zeroed at start of each frame's processing, i.e. parsing virtual method invocation sequence.

### Members

`buffer` (Gst.Buffer) –

input data to be parsed for frames.

`out_buffer` (Gst.Buffer) –

output data.

`flags` (int) –

a combination of input and output GstBase.BaseParseFrameFlags that convey additional context to subclass or allow subclass to tune subsequent GstBase.BaseParse actions.

`offset` (int) –

media specific offset of input frame Note that a converter may have a different one on the frame's buffer.

`overhead` (int) –

subclass can set this to indicates the metadata overhead for the given frame, which is then used to enable more accurate bitrate computations. If this is -1, it is assumed that this frame should be skipped in bitrate calculation.

### Constructors

#### gst_base_parse_frame_new

    GstBaseParseFrame *
    gst_base_parse_frame_new (GstBuffer * buffer,
                              GstBaseParseFrameFlags flags,
                              gint overhead)

Allocates a new GstBaseParseFrame. This function is mainly for bindings, elements written in C should usually allocate the frame on the stack and then use gst_base_parse_frame_init to initialise it.

Parameters:

`buffer` ( [transfer: none]) –

a GstBuffer

`flags` –

the flags

`overhead` –

number of bytes in this frame which should be counted as metadata overhead, ie. not used to calculate the average bitrate. Set to -1 to mark the entire frame as metadata. If in doubt, set to 0.

Returns –

a newly-allocated GstBaseParseFrame. Free with gst_base_parse_frame_free when no longer needed.

#### GstBase.BaseParseFrame.prototype.new

    function GstBase.BaseParseFrame.prototype.new(buffer: Gst.Buffer, flags: GstBase.BaseParseFrameFlags, overhead: Number): {
        // javascript wrapper for 'gst_base_parse_frame_new'
    }

Allocates a new GstBase.BaseParseFrame. This function is mainly for bindings, elements written in C should usually allocate the frame on the stack and then use GstBase.BaseParseFrame.prototype.init to initialise it.

Parameters:

`buffer` (Gst.Buffer) –

a Gst.Buffer

`flags` (GstBase.BaseParseFrameFlags) –

the flags

`overhead` (Number) –

number of bytes in this frame which should be counted as metadata overhead, ie. not used to calculate the average bitrate. Set to -1 to mark the entire frame as metadata. If in doubt, set to 0.

Returns (GstBase.BaseParseFrame) –

a newly-allocated GstBase.BaseParseFrame. Free with GstBase.BaseParseFrame.prototype.free when no longer needed.

#### GstBase.BaseParseFrame.new

    def GstBase.BaseParseFrame.new (buffer, flags, overhead):
        #python wrapper for 'gst_base_parse_frame_new'

Allocates a new GstBase.BaseParseFrame. This function is mainly for bindings, elements written in C should usually allocate the frame on the stack and then use GstBase.BaseParseFrame.init to initialise it.

Parameters:

`buffer` (Gst.Buffer) –

a Gst.Buffer

`flags` (GstBase.BaseParseFrameFlags) –

the flags

`overhead` (int) –

number of bytes in this frame which should be counted as metadata overhead, ie. not used to calculate the average bitrate. Set to -1 to mark the entire frame as metadata. If in doubt, set to 0.

Returns (GstBase.BaseParseFrame) –

a newly-allocated GstBase.BaseParseFrame. Free with GstBase.BaseParseFrame.free when no longer needed.

### Methods

#### gst_base_parse_frame_copy

    GstBaseParseFrame *
    gst_base_parse_frame_copy (GstBaseParseFrame * frame)

Copies a GstBaseParseFrame.

Parameters:

`frame` –

a GstBaseParseFrame

Returns –

A copy of frame

Since : 1.12.1

#### GstBase.BaseParseFrame.prototype.copy

    function GstBase.BaseParseFrame.prototype.copy(): {
        // javascript wrapper for 'gst_base_parse_frame_copy'
    }

Copies a GstBase.BaseParseFrame.

Parameters:

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

Returns (GstBase.BaseParseFrame) –

A copy of frame

Since : 1.12.1

#### GstBase.BaseParseFrame.copy

    def GstBase.BaseParseFrame.copy (self):
        #python wrapper for 'gst_base_parse_frame_copy'

Copies a GstBase.BaseParseFrame.

Parameters:

`frame` (GstBase.BaseParseFrame) –

a GstBase.BaseParseFrame

Returns (GstBase.BaseParseFrame) –

A copy of frame

Since : 1.12.1

#### gst_base_parse_frame_free

    gst_base_parse_frame_free (GstBaseParseFrame * frame)

Frees the provided frame.

Parameters:

`frame` –

A GstBaseParseFrame

#### GstBase.BaseParseFrame.prototype.free

    function GstBase.BaseParseFrame.prototype.free(): {
        // javascript wrapper for 'gst_base_parse_frame_free'
    }

Frees the provided frame.

Parameters:

`frame` (GstBase.BaseParseFrame) –

A GstBase.BaseParseFrame

#### GstBase.BaseParseFrame.free

    def GstBase.BaseParseFrame.free (self):
        #python wrapper for 'gst_base_parse_frame_free'

Frees the provided frame.

Parameters:

`frame` (GstBase.BaseParseFrame) –

A GstBase.BaseParseFrame

#### gst_base_parse_frame_init

    gst_base_parse_frame_init (GstBaseParseFrame * frame)

Sets a GstBaseParseFrame to initial state. Currently this means all public fields are zero-ed and a private flag is set to make sure gst_base_parse_frame_free only frees the contents but not the actual frame. Use this function to initialise a GstBaseParseFrame allocated on the stack.

Parameters:

`frame` –

GstBaseParseFrame.

#### GstBase.BaseParseFrame.prototype.init

    function GstBase.BaseParseFrame.prototype.init(): {
        // javascript wrapper for 'gst_base_parse_frame_init'
    }

Sets a GstBase.BaseParseFrame to initial state. Currently this means all public fields are zero-ed and a private flag is set to make sure GstBase.BaseParseFrame.prototype.free only frees the contents but not the actual frame. Use this function to initialise a GstBase.BaseParseFrame allocated on the stack.

Parameters:

`frame` (GstBase.BaseParseFrame) –

GstBase.BaseParseFrame.

#### GstBase.BaseParseFrame.init

    def GstBase.BaseParseFrame.init (self):
        #python wrapper for 'gst_base_parse_frame_init'

Sets a GstBase.BaseParseFrame to initial state. Currently this means all public fields are zero-ed and a private flag is set to make sure GstBase.BaseParseFrame.free only frees the contents but not the actual frame. Use this function to initialise a GstBase.BaseParseFrame allocated on the stack.

Parameters:

`frame` (GstBase.BaseParseFrame) –

GstBase.BaseParseFrame.

## Function Macros

### GST_BASE_PARSE_CAST

    #define GST_BASE_PARSE_CAST(obj)       ((GstBaseParse *)(obj))

### GST_BASE_PARSE_DRAINING

    #define GST_BASE_PARSE_DRAINING(parse)  (!!(GST_BASE_PARSE_CAST(parse)->flags & GST_BASE_PARSE_FLAG_DRAINING))

Obtains current drain status (ie. whether EOS has been received and the parser is now processing the frames at the end of the stream)

Parameters:

`parse` –

base parse instance

### GST_BASE_PARSE_LOST_SYNC

    #define GST_BASE_PARSE_LOST_SYNC(parse) (!!(GST_BASE_PARSE_CAST(parse)->flags & GST_BASE_PARSE_FLAG_LOST_SYNC))

Obtains current sync status.

Parameters:

`parse` –

base parse instance

### GST_BASE_PARSE_SINK_PAD

    #define GST_BASE_PARSE_SINK_PAD(obj)    (GST_BASE_PARSE_CAST (obj)->sinkpad)

Gives the pointer to the sink GstPad object of the element.

Parameters:

`obj` –

base parse instance

### GST_BASE_PARSE_SRC_PAD

    #define GST_BASE_PARSE_SRC_PAD(obj)    (GST_BASE_PARSE_CAST (obj)->srcpad)

Gives the pointer to the source GstPad object of the element.

Parameters:

`obj` –

base parse instance

## Enumerations

### GstBaseParseFrameFlags

Flags to be used in a GstBaseParseFrame.

##### Members

`GST_BASE_PARSE_FRAME_FLAG_NONE` (0) –

no flag

`GST_BASE_PARSE_FRAME_FLAG_NEW_FRAME` (1) –

set by baseclass if current frame is passed for processing to the subclass for the first time (and not set on subsequent calls with same data).

`GST_BASE_PARSE_FRAME_FLAG_NO_FRAME` (2) –

set to indicate this buffer should not be counted as frame, e.g. if this frame is dependent on a previous one. As it is not counted as a frame, bitrate increases but frame to time conversions are maintained.

`GST_BASE_PARSE_FRAME_FLAG_CLIP` (4) –

pre_push_frame can set this to indicate that regular segment clipping can still be performed (as opposed to any custom one having been done).

`GST_BASE_PARSE_FRAME_FLAG_DROP` (8) –

indicates to finish_frame that the the frame should be dropped (and might be handled internally by subclass)

`GST_BASE_PARSE_FRAME_FLAG_QUEUE` (16) –

indicates to finish_frame that the the frame should be queued for now and processed fully later when the first non-queued frame is finished

### GstBase.BaseParseFrameFlags

Flags to be used in a GstBase.BaseParseFrame.

##### Members

`GstBase.BaseParseFrameFlags.NONE` (0) –

no flag

`GstBase.BaseParseFrameFlags.NEW_FRAME` (1) –

set by baseclass if current frame is passed for processing to the subclass for the first time (and not set on subsequent calls with same data).

`GstBase.BaseParseFrameFlags.NO_FRAME` (2) –

set to indicate this buffer should not be counted as frame, e.g. if this frame is dependent on a previous one. As it is not counted as a frame, bitrate increases but frame to time conversions are maintained.

`GstBase.BaseParseFrameFlags.CLIP` (4) –

pre_push_frame can set this to indicate that regular segment clipping can still be performed (as opposed to any custom one having been done).

`GstBase.BaseParseFrameFlags.DROP` (8) –

indicates to finish_frame that the the frame should be dropped (and might be handled internally by subclass)

`GstBase.BaseParseFrameFlags.QUEUE` (16) –

indicates to finish_frame that the the frame should be queued for now and processed fully later when the first non-queued frame is finished

### GstBase.BaseParseFrameFlags

Flags to be used in a GstBase.BaseParseFrame.

##### Members

`GstBase.BaseParseFrameFlags.NONE` (0) –

no flag

`GstBase.BaseParseFrameFlags.NEW_FRAME` (1) –

set by baseclass if current frame is passed for processing to the subclass for the first time (and not set on subsequent calls with same data).

`GstBase.BaseParseFrameFlags.NO_FRAME` (2) –

set to indicate this buffer should not be counted as frame, e.g. if this frame is dependent on a previous one. As it is not counted as a frame, bitrate increases but frame to time conversions are maintained.

`GstBase.BaseParseFrameFlags.CLIP` (4) –

pre_push_frame can set this to indicate that regular segment clipping can still be performed (as opposed to any custom one having been done).

`GstBase.BaseParseFrameFlags.DROP` (8) –

indicates to finish_frame that the the frame should be dropped (and might be handled internally by subclass)

`GstBase.BaseParseFrameFlags.QUEUE` (16) –

indicates to finish_frame that the the frame should be queued for now and processed fully later when the first non-queued frame is finished

## Constants

### GST_BASE_PARSE_FLAG_DRAINING

    #define GST_BASE_PARSE_FLAG_DRAINING  (1 << 1)

### GstBase.BASE_PARSE_FLAG_DRAINING

### GST_BASE_PARSE_FLAG_LOST_SYNC

    #define GST_BASE_PARSE_FLAG_LOST_SYNC (1 << 0)

### GstBase.BASE_PARSE_FLAG_LOST_SYNC

### GST_BASE_PARSE_FLOW_DROPPED

    #define GST_BASE_PARSE_FLOW_DROPPED     GST_FLOW_CUSTOM_SUCCESS

A GstFlowReturn that can be returned from handle_frame to indicate that no output buffer was generated, or from pre_push_frame to to forego pushing buffer.

The results of the search are